; KFM's constants and state file.
; There are comments scattered through this file, so you may like to
; take a look if would like to learn more about the cns.

; KFM̒萔ƏԂ̃t@CłB
; ̃t@C̒ɂ͒߂U炳Ă̂ŁACNSK
; ǂł݂炢łB

[Data]
;Amount of life to start with
;̗̓Q[W̏l
life = 250
;Amount of power stocks to have (divided by 1000). Defaults to 3000
power = 3000
;attack power (more is stronger)
;U_[W
attack = 25
;defensive power (more is stronger)
;̗̓p[
defence = 100
;Percentage to increase defense everytime player is knocked down
fall.defence_up = 50
;Time which player lies down for, before getting up
liedown.time = 10
;Number of points for juggling
airjuggle = 1 ; yes, that "many" juggle points
;Default hit spark number for HitDefs
sparkno = 2
;Default guard spark number
guard.sparkno = -1
;1 to enable echo on KO
KO.echo = 0
;Volume offset (negative for softer)
volume = 0
;Variables with this index and above will not have their values
;reset to 0 between rounds or matches. There are 60 int variables,
;indexed from 0 to 59, and 40 float variables, indexed from 0 to 39.
;If omitted, then it defaults to 60 and 40 for integer and float
;variables repectively, meaning that none are persistent, i.e. all
;are reset. If you want your variables to persist between matches,
;you need to override state 5900 from common1.cns.
IntPersistIndex = 58
FloatPersistIndex = 40

[Size]
xscale = 0.8           ;Horizontal scaling factor.
yscale = 0.94488           ;Vertical scaling factor.
;xscale = 1
;yscale = 1
ground.back = 20     ;Player width (back, ground)
ground.front = 19    ;Player width (front, ground)
air.back = 20        ;Player width (back, air)
air.front = 19       ;Player width (front, air)
height = 60          ;Height of player (for opponent to jump over)
attack.dist = 160    ;Default attack distance
proj.attack.dist = 90 ;Default attack distance for projectiles
proj.doscale = 0     ;Set to 1 to scale projectiles too
head.pos = -5, -108   ;Approximate position of head
mid.pos = 0, -55    ;Approximate position of midsection
shadowoffset = 0     ;Number of pixels to vertically offset the shadow
draw.offset = 0,0    ;Player drawing offset in pixels (x, y)

[Velocity]
walk.fwd  = 3      ;Walk forward
walk.back = -3     ;Walk backward
run.fwd  = 6.2, 0    ;Run forward (x, y)
run.back = -5,-6.7 ;Hop backward (x, y)
jump.neu = 0,-13    ;Neutral jumping velocity (x, y)
jump.back = -4    ;Jump back Speed (x, y)
jump.fwd = 4       ;Jump forward Speed (x, y)
runjump.back = -2.55,-8.1 ;Running jump speeds (opt)
runjump.fwd = 4,-8.1      ;.
airjump.neu = 0,-13.13      ;.
airjump.back = -3.55      ;Air jump speeds (opt)
airjump.fwd = 3.5         ;.
air.gethit.groundrecover = -.15,-3.5  ;Velocity for ground recovery state (x, y) **MUGEN 1.0**
air.gethit.airrecover.mul = .5,.2     ;Multiplier for air recovery velocity (x, y) **MUGEN 1.0**
air.gethit.airrecover.add = 0,-4.5    ;Velocity offset for air recovery (x, y) **MUGEN 1.0**
air.gethit.airrecover.back = -1       ;Extra x-velocity for holding back during air recovery **MUGEN 1.0**
air.gethit.airrecover.fwd = 0         ;Extra x-velocity for holding forward during air recovery **MUGEN 1.0**
air.gethit.airrecover.up = -2         ;Extra y-velocity for holding up during air recovery **MUGEN 1.0**
air.gethit.airrecover.down = 1.5      ;Extra y-velocity for holding down during air recovery **MUGEN 1.0**

[Movement]
airjump.num = 0      ;Number of air jumps allowed (opt)
airjump.height = 35  ;Minimum distance from ground before you can air jump (opt)
yaccel = .84         ;POTS was right, elecbyte's default gravity was floaty as fuck so I've changed that here
stand.friction = .85  ;Friction coefficient when standing
crouch.friction = .82 ;Friction coefficient when crouching
stand.friction.threshold = 2          ;If player's speed drops below this threshold while standing, stop his movement **MUGEN 1.0**
crouch.friction.threshold = .05       ;If player's speed drops below this threshold while crouching, stop his movement **MUGEN 1.0**
air.gethit.groundlevel = 25           ;Y-position at which a falling player is considered to hit the ground **MUGEN 1.0**
air.gethit.groundrecover.ground.threshold = -20 ;Y-position below which falling player can use the recovery command **MUGEN 1.0**
air.gethit.groundrecover.groundlevel = 10   ;Y-position at which player in the ground recovery state touches the ground **MUGEN 1.0**
air.gethit.airrecover.threshold = -1  ;Y-velocity above which player may use the air recovery command **MUGEN 1.0**
air.gethit.airrecover.yaccel = .35    ;Vertical acceleration for player in the air recovery state **MUGEN 1.0**
air.gethit.trip.groundlevel = 15      ;Y-position at which player in the tripped state touches the ground **MUGEN 1.0**
down.bounce.offset = 0, 20            ;Offset for player bouncing off the ground (x, y) **MUGEN 1.0**
down.bounce.yaccel = .4               ;Vertical acceleration for player bouncing off the ground **MUGEN 1.0**
down.bounce.groundlevel = 12          ;Y-position at which player bouncing off the ground touches the ground again **MUGEN 1.0**
down.friction.threshold = .05         ;If the player's speed drops below this threshold while lying down, stop his movement **MUGEN 1.0**

;Default language victory quotes (optional).  **MUGEN 1.0**
;If this section is included, the default language victory quotes must be in English.
[Quotes]
; Up to 100 victory quotes can be specified per language (victory0 - victory99)
victory0 = "you have strong hercules"
victory1 = "dude mugen"
victory2 = "robert raccoon gonna be 2012"
victory3 = "FILMED ON LOCATION....STUFF"
victory4 = "R.I.P. megaupload 2005-2012 what the fuck it this"
victory5 = "We all the Best of Aracdboy"
victory6 = "Who are you? answer me GOD DAM IT :P"
victory7 = "mame roms 2012"
victory8 = "Cartoon Network Canada 2012"
victory9 = "3-we need a user like The Noooo or other (because I have fraps which records only for 30 seconds)"
victory10 = "Just get to the RAGE FluidGames The Rage"
victory11 = "aracdboy1 HalloWeen Death Man"
victory12 = "Cartoon Network Coming sept.5 New Episode"
victory13 = "Vancouver 2010 finished"
victory14 = "Blood nose holy crap"
victory15 = "freerealms sucked MAME is wonderful"
victory16 = "Earth day wear green"
victory17 = "100th FUCK YOU MUSTKILLROY mugen"
victory18 = "great dick:be out guess"
victory19 = "YOU ARE TROLL GOING TO THE 2012"
victory20 = "Thumbs up, baby."
victory21 = "sanic mugen play tribes"

;---------------------------------------------------------------------------
; Stand
[Statedef 0]
type = S
physics = S
sprpriority = 0

[State 0, ]
type = CtrlSet
trigger1 = !ishelper
trigger1 = roundstate = 3
value = 1

[State 0, ]
type = CtrlSet
trigger1 = ishelper
value = 0

[State 0, 1]
type = ChangeAnim
trigger1 = Anim != 0 && Anim != 5
trigger2 = Anim = 5 && AnimTime = 0 ;Turn anim over
value = 0

[State 0, 2]
type = VelSet
trigger1 = Time = 0
y = 0

[State 0, 3] ;Stop moving if low velocity or 4 ticks pass
type = VelSet
trigger1 = abs(vel x) < 2
trigger2 = Time = 4
x = 0

;---------------------------------------------------------------------------
; KO Voice
[Statedef 179]
type = S
ctrl = 0
anim = 9741
velset = 0,0

[State 0, VarSet]
type = VarSet
trigger1 = time = 0
var(55) = 4000
[State 0, VarSet]
type = VarAdd
trigger1 = roundstate = 2
trigger1 = var(55) > 0
trigger1 = (enemy, ctrl) || var(55) < 4000
var(55) = -1

[State 0, ChangeState]
type = ChangeState
trigger1 = roundstate < 1
trigger1 = parent,stateno = [170,183]
value = 178
ctrl = 0

[State WHAM Timer]
type = VarSet
trigger1 = 1
var(30) = parent,var(33)
ignorehitpause = 1
[State WHAM Timer]
type = VarSet
trigger1 = (parent,var(33)=0)
v = 32
value = 0
ignorehitpause = 1
[State WHAM Timer]
type = VarAdd
trigger1 = (parent,var(33)!=0)
v = 32
value = 1
ignorehitpause = 1
[State WHAM]
type = PlaySnd
;trigger1 = parent,numtarget
;trigger1 = var(30)
;trigger1 = playerID(var(30)),stateno = 227
;trigger1 = playerID(var(30)),time = 1
;trigger1 = playerID(var(30)),movetype = H
trigger1 = var(30) = 1
trigger1 = var(32) = 1
value = S0,22
freqmul = 1.0
ignorehitpause = 1
[State WHAM]
type = PlaySnd
;trigger1 = parent,numtarget
;trigger1 = var(30)
;trigger1 = playerID(var(30)),stateno = 227
;trigger1 = playerID(var(30)),time = 1
;trigger1 = playerID(var(30)),movetype = H
trigger1 = var(30) = 2
trigger1 = var(32) = 1
value = S0,24
freqmul = 1.0
ignorehitpause = 1
[State ICYCLES]
type = Explod
trigger1 = var(30) = 2
trigger1 = var(32) = 1
anim = 106
ID = 106
pos = -32,0
vel = -2,0
accel = 0.0714285714285714,0
postype = p2
facing = 1
vfacing = 1
bindtime = 1
removetime = -2
scale = 1,1
sprpriority = 4
ownpal = 1


[State PERFECT]
type = PlaySnd
trigger1 = winko
trigger1 = roundstate = 3
trigger1 = enemy,life = lifemax
value = S0,25
volume = 255
abspan = 0
ignorehitpause = 1
persistent = 0

[State 0, VarSet]
type = VarAdd
trigger1 = var(12) > 0
trigger1 = numexplod(947)
var(12) = -1
[State 0, VarSet]
type = VarSet
trigger1 = fvar(13) != 0
trigger1 = !numexplod(947)
fvar(13) = 0
[State 0, VarSet]
type = VarAdd
trigger1 = var(12) > 0
trigger1 = fvar(13) < .5
trigger1 = numexplod(947)
fvar(13) = 0.05
[State 0, VarSet]
type = VarAdd
trigger1 = fvar(13) > 0
trigger1 = numexplod(947)
trigger1 = var(12) <= 0
fvar(13) = -0.05
[State 0, VarSet]
type = VarSet
trigger1 = fvar(13) > .5
trigger1 = var(12) > 0
trigger1 = numexplod(947)
fvar(13) = .5



[State 0, VarSet]
type = VarSet
trigger1 = (p2movetype = H || (p2stateno = [5000,5110])) && roundstate < 3
var(14) = 0
ignorehitpause = 1
[State 0, VarSet]
type = VarAdd
trigger1 = (p2movetype != H && (p2stateno != [5000,5110])) || roundstate >= 3
trigger1 = var(14) < 10
var(14) = 1
ignorehitpause = 1
[State remember p2 life]
type = VarSet
trigger1 = var(14) >= 2
trigger1 = (p2movetype != H && (p2stateno != [5000,5110])) || roundstate >= 3
var(13) = p2life
ignorehitpause = 1


; STATS TRACKER
; var(40) - current consecutive hits
; var(50) - max consecutive hits
; var(41) - current combo
; var(51) - max combo
; var(42) - number of attacks
; var(52) - number of hits
; var(53) - FATALITY FINISH
; var(54) - SOVIET DAMAGE count
; var(55) - sanec
; var(43) - u
; fvar(42) - accuracy

[State -2, Movehitoner]
type = VarSet
trigger1 = numenemy
var(21) = ifelse((enemy,movehit=1),var(21)+1,0)
ignorehitpause = 1
[State Count Combo]
type = VarSet
trigger1 = numenemy
var(43) = enemy,uniqhitcount
[State Count Combo]
type = VarAdd
trigger1 = var(44)<var(43)
var(41) = var(43)-var(44)
[State Count Consecutive Hits]
type = VarAdd
trigger1 = var(44)<var(43)
var(40) = var(43)-var(44)
[State Count Hit]
type = VarAdd
trigger1 = var(44)<var(43)
var(52) = var(43)
[State Count Combo]
type = VarSet
trigger1 = var(44)<var(43)
var(44) = var(43)
[State Count Combo]
type = VarSet
trigger1 = numenemy
trigger1 = enemy,uniqhitcount=0
var(44) = 0
[State Reset Combo]
type = VarSet
trigger1 = numenemy
trigger1 = !(enemy,numtarget)
;trigger2 = numhelper(666)
;trigger2 = (helper(666),movetype != H) || (!helper(666),gethitvar(hitcount))
;trigger2 = !movehit || movereversed
var(41) = 0*(var(44):=0)
[State Record Combo]
type = VarSet
trigger1 = var(51) < var(41)
var(51) = var(41)
[State Reset Consecutive Hits]
type = VarSet
trigger1 = enemy,movetype=H
trigger1 = enemy,stateno!=[120,156]
var(40) = 0
[State Record Consecutive Hits]
type = VarSet
trigger1 = var(50) < var(40)
var(50) = var(40)
[State Count Attacks]
type = VarAdd
trigger1 = (enemy,movetype = A)
trigger1 = enemy,time = 1
var(42) = 1
[State Likely Debug Stuff]
type = VarSet
trigger1 = 1
fvar(0) = var(42)
[State Likely Debug Stuff]
type = VarSet
trigger1 = 1
fvar(1) = var(52)
[State Likely Debug Stuff]
type = VarSet
trigger1 = fvar(0)!=0
fvar(32) = fvar(1)/fvar(0)
[State Reset Fatality Finish]
type = VarSet
trigger1 = roundstate = 2
var(53) = 0
[State Check Fatality Finish]
type = VarSet
trigger1 = enemy,HitDefAttr = SCA, HA,HP,HT
var(53) = 1

[State 0, DisplayToClipboard]
type = DisplayToClipboard
trigger1 = 1
text = "consecutives = %d / %d combo = %d / %d accuracy = %f"
params = var(40),var(50),var(41),var(51),fvar(32)
[State 0, AppendToClipboard]
type = AppendToClipboard
trigger1 = 1
text = "\nvar(13) = %d damage = %d (%d)"
params = var(13),abs(p2life - var(13)),var(14)
ignorehitpause = 1



;

[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = roundstate = 4
trigger1 = numexplod(947)
flag = roundnotover

[State 0, ChangeState]
type = ChangeState
triggerall = enemy,win
trigger1 = roundstate = 4
trigger1 = !numexplod(947)
value = 189
ctrl = 0


;---------------------------------------------------------------------------
; Dem Stats
[Statedef 189]
type = S
ctrl = 0
anim = 9741
velset = 0,0

[State Somethin']
type = VarSet
trigger1 = time = 0
fvar(0) = var(42)
[State Somethin']
type = VarSet
trigger1 = time = 0
fvar(1) = var(52)
[State Calculate the score right off the bat]
type = VarSet
trigger1 = time = 0
var(0) = ifelse((enemy,life = enemy,lifemax),2000,(enemy,life))
[State Calculate the score right off the bat]
type = VarAdd
trigger1 = time = 0
var(0) = (var(50)*100) + (var(51)*100) + floor( (fvar(1)/fvar(0))*1000) + floor(var(54)*1.5)
[State Calculate the score right off the bat]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(38) >= 1
var(0) = floor(var(0) / ((parent,var(38))))
[State Calculate the score right off the bat]
type = VarAdd
trigger1 = time = 0
var(0) = 1000*var(53)
[State Calculate the score right off the bat]
type = VarAdd
trigger1 = time = 0
var(0) = var(55)
[State 0, ParentVarAdd]
type = ParentVarAdd
trigger1 = time = 1
var(59) = var(0)

[State 0, BGPalFX]
type = BGPalFX
trigger1 = 1
time = 4
mul = 200,200,200
color = 200
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = time = 0
var(30) = 0
[State 0, VarSet]
type = VarSet
trigger1 = time = 0
var(11) = 0

[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = 1
flag = nobardisplay
[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = time = [0,500]
flag = roundnotover

; 18
[State 0, VarSet]
type = VarSet
trigger1 = time = 16
var(14) = enemy,life
[State 0, BONUS]
type = VarSet
trigger1 = time = 16
trigger1 = enemy,life = enemy,lifemax
var(14) = var(14) * 2
[State Likely Debug Stuff]
type = VarSet
trigger1 = time = 34
fvar(0) = var(42)
[State Likely Debug Stuff]
type = VarSet
trigger1 = time = 34
fvar(1) = var(52)
[State 0, VarSet]
type = VarSet
trigger1 = time = 34
trigger1 = var(42) != 0
var(14) = floor( (fvar(1)/fvar(0))*1000)
[State 0, VarSet]
type = VarSet
trigger1 = time = 34
trigger1 = var(42) = 0
var(14) = 1000
[State 0, VarSet]
type = VarSet
trigger1 = time = 52
var(14) = var(50)*100
[State 0, VarSet]
type = VarSet
trigger1 = time = 70
var(14) = var(51)*100
[State 0, VarSet]
type = VarSet
trigger1 = time = 89
var(14) = (parent,var(39))*15
[State 0, VarSet]
type = VarSet
trigger1 = time = 108
var(14) = floor(var(54)*1.5)
[State 0, VarSet]
type = VarSet
trigger1 = time = 140
var(14) = var(53)*1000
[State 0, VarSet]
type = VarSet
trigger1 = time = 158
var(14) = var(55)
[State 0, BONUS]
type = VarAdd
trigger1 = time = 16
trigger2 = time = 34
trigger3 = time = 52
trigger4 = time = 70
trigger5 = time = 89
trigger6 = time = 108
trigger7 = time = 140
trigger8 = time = 158
var(30) = var(14)
[State 0, VarSet]
type = VarSet
trigger1 = time = 124
var(14) = (parent,var(38))
[State 0, Suckage]
type = VarSet
trigger1 = time = 124
trigger1 = var(14) >= 1
var(30) = var(30) / (var(14))


[State 0, x-pos]
type = VarSet
trigger1 = time = 16
trigger2 = time = 70
trigger3 = time = 124
var(15) = 40
[State 0, x-pos]
type = VarAdd
trigger1 = time = 34
trigger2 = time = 52
trigger3 = time = 89
trigger4 = time = 108
trigger5 = time = 140
trigger6 = time = 158
var(15) = 100
[State 0, y-pos]
type = VarSet
trigger1 = time = 16
var(16) = 32
[State 0, y-pos]
type = VarAdd
trigger1 = time = 70
trigger2 = time = 124
var(16) = 30
[State 0, icon]
type = VarAdd
trigger1 = time = 34
trigger2 = time = 52
trigger3 = time = 70
trigger4 = time = 89
trigger5 = time = 108
trigger6 = time = 124
trigger7 = time = 140
trigger8 = time = 158
var(11) = 1



[State FINAL, x-pos]
type = VarSet
trigger1 = time = 179
var(15) = 140
[State FINAL, y-pos]
type = VarSet
trigger1 = time = 179
var(16) = 180
[State FINAL, score]
type = VarSet
trigger1 = time = 179
var(14) = var(30)
[State FINAL, rank]
type = VarSet
trigger1 = time = 179
var(11) = 10+ifelse(var(30)>=8000,8,floor(var(30)/1000))

[State Pick a letter]
type = VarSet
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
var(0) = (var(14)%10)
[State Pick a letter]
type = VarSet
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
var(1) = (floor(var(14)/10)%10)
[State Pick a letter]
type = VarSet
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
var(2) = (floor(var(14)/100)%10)
[State Pick a letter]
type = VarSet
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
var(3) = (floor(var(14)/1000)%10)
[State Pick a letter]
type = VarSet
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
var(4) = (floor(var(14)/10000)%10)

[State CLUNK]
type = PlaySnd
triggerall = var(14) >= 1
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
value = S0,22
abspan = 0
[State CLUNK]
type = PlaySnd
triggerall = var(14) >= 1
trigger1 = time = 180
value = S189,var(11)-10
abspan = 0
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = time = 180
trigger1 = (var(11)-10) = 8
id = 4501
ignorehitpause = 1
[State icon]
type = Explod
triggerall = var(14) >= 1
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
id = ifelse(time>=180,4509,4501)
anim = 4510+var(11)
pos = var(15)-8,var(16)
postype = left
bindtime = -1
removetime = -1
scale = .5,.5
sprpriority = 979
ontop = 1
ownpal = 1
[State number 1]
type = Explod
triggerall = var(14) >= 10000
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
id = ifelse(time>=180,4509,4501)
anim = 4500+var(4)
pos = var(15),var(16)
postype = left
bindtime = -1
removetime = -1
scale = .5,.5
sprpriority = 980
ontop = 1
ownpal = 1
[State number 2]
type = Explod
triggerall = var(14) >= 1000
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
id = ifelse(time>=180,4509,4501)
anim = 4500+var(3)
pos = var(15)+8,var(16)
postype = left
bindtime = -1
removetime = -1
scale = .5,.5
sprpriority = 980
ontop = 1
ownpal = 1
[State number 3]
type = Explod
triggerall = var(14) >= 100
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
id = ifelse(time>=180,4509,4501)
anim = 4500+var(2)
pos = var(15)+16,var(16)
postype = left
bindtime = -1
removetime = -1
scale = .5,.5
sprpriority = 980
ontop = 1
ownpal = 1
[State number 4]
type = Explod
triggerall = var(14) >= 10
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
id = ifelse(time>=180,4509,4501)
anim = 4500+var(1)
pos = var(15)+24,var(16)
postype = left
bindtime = -1
removetime = -1
scale = .5,.5
sprpriority = 980
ontop = 1
ownpal = 1
[State number 5]
type = Explod
triggerall = var(14) >= 1
trigger1 = time = 18
trigger2 = time = 36
trigger3 = time = 54
trigger4 = time = 72
trigger5 = time = 90
trigger6 = time = 108
trigger7 = time = 126
trigger8 = time = 144
trigger9 = time = 162
trigger10 = time = 180
id = ifelse(time>=180,4509,4501)
anim = 4500+var(0)
pos = var(15)+32,var(16)
postype = left
bindtime = -1
removetime = -1
scale = .5,.5
sprpriority = 980
ontop = 1
ownpal = 1

[State 0, Explod]
type = Explod
trigger1 = (var(11)-10) = 8
trigger1 = time = 180 + 8
anim = 4540
ID = 4540
pos = 160,50
postype = left
facing = 1
vfacing = 1
bindtime = 1
removetime = -1
pausemovetime = 65535
scale = 1,1
sprpriority = 65535
ontop = 1
ownpal = 1
removeongethit = 1
[State 0, Explod]
type = Explod
trigger1 = (var(11)-10) = 8
trigger1 = time = 180 + 118
anim = 4541
ID = 4540
pos = 160,65
postype = left
facing = 1
vfacing = 1
bindtime = 1
removetime = -1
pausemovetime = 65535
scale = 1,1
sprpriority = 65535
ontop = 1
ownpal = 1
removeongethit = 1
[State 0, Explod]
type = Explod
trigger1 = (var(11)-10) = 8
trigger1 = time = 180 + 162
anim = 4542
ID = 4540
pos = 160,80
postype = left
facing = 1
vfacing = 1
bindtime = 1
removetime = -1
pausemovetime = 65535
scale = 1,1
sprpriority = 65535
ontop = 1
ownpal = 1
removeongethit = 1
[State 0, Explod]
type = Explod
trigger1 = (var(11)-10) = 8
trigger1 = time = 180 + 232
anim = 4543
ID = 4540
pos = 160,105
postype = left
facing = 1
vfacing = 1
bindtime = 1
removetime = -1
pausemovetime = 65535
scale = 1.5,1.5
sprpriority = 65535
ontop = 1
ownpal = 1
removeongethit = 1


;---------------------------------------------------------------------------
; Turn
[Statedef 5]
type = S
physics = S
sprpriority = 0
anim = 5

[State 0, ]
type = Turn
trigger1 = time = 0
ignorehitpause = 1

[State 0, 2]
type = VelSet
trigger1 = Time = 0
y = 0

[State 0, 3] ;Stop moving if low velocity or 4 ticks pass
type = VelSet
trigger1 = abs(vel x) < 2
trigger2 = Time = 4
x = 0

[State 0, ]
type = ChangeState
trigger1 = animtime = 0
value = 0
ctrl = 0

;---------------------------------------------------------------------------
; Turn
[Statedef 6]
type = S
physics = S
sprpriority = 0
anim = 6

[State 0, ]
type = Turn
trigger1 = time = 0
ignorehitpause = 1

[State 0, 2]
type = VelSet
trigger1 = Time = 0
y = 0

[State 0, 3] ;Stop moving if low velocity or 4 ticks pass
type = VelSet
trigger1 = abs(vel x) < 2
trigger2 = Time = 4
x = 0

[State 0, ]
type = ChangeState
trigger1 = animtime = 0
value = 11
ctrl = 0

;---------------------------------------------------------------------------
; Walk Forward
[Statedef 20]
type    = S
physics = S
sprpriority = 0

[State 20, 1]
type = VelSet
trigger1 = 1
x = const(velocity.walk.fwd.x)

[State 20, 3]
type = ChangeAnim
triggerall = vel x > 0
trigger1 = Anim != 20 && Anim != 5
trigger2 = Anim = 5 && AnimTime = 0
value = 20

;---------------------------------------------------------------------------
; Walk Backward
[Statedef 21]
type    = S
physics = S
sprpriority = 0

[State 20, 2]
type = VelSet
trigger1 = 1
x = const(velocity.walk.back.x)

[State 20, 3]
type = ChangeAnim
triggerall = vel x > 0
trigger1 = Anim != 20 && Anim != 5
trigger2 = Anim = 5 && AnimTime = 0
value = 20

[State 20, 4]
type = ChangeAnim
triggerall = vel x < 0
trigger1 = Anim != 21 && Anim != 5
trigger2 = Anim = 5 && AnimTime = 0
value = 21


;---------------------------------------------------------------------------
; Global State
[Statedef 1]
type = S
physics = S
sprpriority = 0
anim = 9741

[State 0, VarSet]
type = VarSet
trigger1 = time = 0
var(0) = 0
[State 0, VarSet]
type = VarSet
trigger1 = time
trigger1 = command = "a"
var(0) = 1
[State 0, VarSet]
type = VarSet
trigger1 = time
trigger1 = command = "b"
var(0) = 2
[State 0, VarSet]
type = VarSet
trigger1 = time
trigger1 = command = "c"
var(0) = 3
[State 0, VarSet]
type = VarSet
trigger1 = time
trigger1 = command = "x"
var(0) = 4
[State 0, VarSet]
type = VarSet
trigger1 = time
trigger1 = command = "y"
var(0) = 5
[State 0, VarSet]
type = VarSet
trigger1 = time
trigger1 = command = "z"
var(0) = 6

[State 0, ]
type = Helper
triggerall = enemy, stateno != 0 || enemy, ctrl != 0
triggerall = power >= 1000
triggerall = numhelper(669) = 0
trigger1 = command = "start"
helpertype = player
name = "Bfg"
ID = 669
pos = -180,0
postype = back
facing = 1
stateno = 116
keyctrl = 1
ownpal = 1
ignorehitpause = 1

[State 0, ]
type = Helper
triggerall = enemy, stateno != 0 || enemy, ctrl != 0
trigger1 = numhelper(666) < 3+(roundsexisted>=1)
trigger1 = var(0)>0
trigger1 = command != "holdfwd" || roundsexisted=0
helpertype = player
name = "Dude"
ID = 666
pos = -180,0
postype = back
facing = 1
stateno = 110+var(0)-1
keyctrl = 1
ownpal = 1
size.ground.back = 20
size.ground.front = 19
size.air.back = 20
size.air.front = 19
size.height = 60
size.attack.dist = 160
size.head.pos = -5, -108
size.mid.pos = 0, -55
ignorehitpause = 1
[State 0, ]
type = Helper
triggerall = enemy, stateno != 0 || enemy, ctrl != 0
trigger1 = numhelper(666) < 3+(roundsexisted>=1)
trigger1 = var(0)>0
trigger1 = command = "holdfwd" && roundsexisted > 0
helpertype = player
name = "Dude"
ID = 666
pos = 180,0
postype = front
facing = -1
stateno = 110+var(0)-1
keyctrl = 1
ownpal = 1
size.ground.back = 20
size.ground.front = 19
size.air.back = 20
size.air.front = 19
size.height = 60
size.attack.dist = 160
size.head.pos = -5, -108
size.mid.pos = 0, -55
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = time
trigger1 = var(0)>0
var(0) = 0

[State 0, 2]
type = VelSet
trigger1 = Time = 0
y = 0

[State 0, 3] ;Stop moving if low velocity or 4 ticks pass
type = VelSet
trigger1 = abs(vel x) < 2
trigger2 = Time = 4
x = 0

[State 0, ]
type = ChangeState
trigger1 = win
value = 0
ctrl = 0

[State 0, ]
type = ChangeState
trigger1 = !alive
value = 5110
ctrl = 0

;---------------------------------------------------------------------------
; Come in as a grappler
[Statedef 110]
type    = S
physics = S
ctrl = 0
anim = 100
sprpriority = 1

[State 0, PosAdd]
type = PosAdd
trigger1 = time = 0
x = -64 - backedgedist

[State 0, ]
type = VarSet
trigger1 = 1
v = 11
value = 1

[State 0, ]
type = VarSet
trigger1 = time = 0
var(55) = 8
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(55)
var(55) = parent,var(55)
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(49)
var(55) = parent,var(49)

[State 0, ]
type = ScreenBound
trigger1 = 1
value = 0

[State 105, 1]
type = VelSet
trigger1 = 1
x = const(velocity.run.fwd.x)

[State 105, 3]
type = ChangeState
trigger1 = animtime = 0
value = 0

;---------------------------------------------------------------------------
; Come in as a sniper
[Statedef 111]
type    = S
physics = S
ctrl = 0
anim = 100
sprpriority = 1

[State 0, PosAdd]
type = PosAdd
trigger1 = time = 0
x = -64 - backedgedist

[State 0, ]
type = VarSet
trigger1 = 1
v = 11
value = 2

[State 0, ]
type = VarSet
trigger1 = time = 0
var(55) = 8
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(55)
var(55) = parent,var(55)
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(49)
var(55) = parent,var(49)

[State 0, ]
type = ScreenBound
trigger1 = 1
value = 0

[State 105, 1]
type = VelSet
trigger1 = 1
x = const(velocity.run.fwd.x)

[State 105, 3]
type = ChangeState
trigger1 = animtime = 0
value = 0

;---------------------------------------------------------------------------
; Come in as a basic assault
[Statedef 112]
type    = S
physics = S
ctrl = 0
anim = 100
sprpriority = 1

[State 0, PosAdd]
type = PosAdd
trigger1 = time = 0
x = -64 - backedgedist

[State 0, ]
type = VarSet
trigger1 = 1
v = 11
value = 3

[State 0, ]
type = VarSet
trigger1 = time = 0
var(55) = 8
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(55)
var(55) = parent,var(55)
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(49)
var(55) = parent,var(49)

[State 0, ]
type = ScreenBound
trigger1 = 1
value = 0

[State 105, 1]
type = VelSet
trigger1 = 1
x = const(velocity.run.fwd.x)

[State 105, 3]
type = ChangeState
trigger1 = animtime = 0
value = 0

;---------------------------------------------------------------------------
; Come in as a combo soldier
[Statedef 113]
type    = S
physics = S
ctrl = 0
anim = 100
sprpriority = 1

[State 0, PosAdd]
type = PosAdd
trigger1 = time = 0
x = -64 - backedgedist

[State 0, ]
type = VarSet
trigger1 = 1
v = 11
value = 4

[State 0, ]
type = VarSet
trigger1 = time = 0
var(55) = 8
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(55)
var(55) = parent,var(55)
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(49)
var(55) = parent,var(49)

[State 0, ]
type = ScreenBound
trigger1 = 1
value = 0

[State 105, 1]
type = VelSet
trigger1 = 1
x = const(velocity.run.fwd.x)

[State 105, 3]
type = ChangeState
trigger1 = animtime = 0
value = 0

;---------------------------------------------------------------------------
; Come in as a juggler
[Statedef 114]
type    = S
physics = S
ctrl = 0
anim = 100
sprpriority = 1

[State 0, PosAdd]
type = PosAdd
trigger1 = time = 0
x = -64 - backedgedist

[State 0, ]
type = VarSet
trigger1 = 1
v = 11
value = 5

[State 0, ]
type = VarSet
trigger1 = time = 0
var(55) = 8
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(55)
var(55) = parent,var(55)
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(49)
var(55) = parent,var(49)

[State 0, ]
type = ScreenBound
trigger1 = 1
value = 0

[State 105, 1]
type = VelSet
trigger1 = 1
x = const(velocity.run.fwd.x)

[State 105, 3]
type = ChangeState
trigger1 = animtime = 0
value = 0
;---------------------------------------------------------------------------
; Come in as a smart guy
[Statedef 115]
type    = S
physics = S
ctrl = 0
anim = 100
sprpriority = 1

[State 0, PosAdd]
type = PosAdd
trigger1 = time = 0
x = -64 - backedgedist

[State 0, ]
type = VarSet
trigger1 = 1
v = 11
value = 6

[State 0, ]
type = VarSet
trigger1 = time = 0
var(55) = 8
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(55)
var(55) = parent,var(55)
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(49)
var(55) = parent,var(49)

[State 0, ]
type = ScreenBound
trigger1 = 1
value = 0

[State 105, 1]
type = VelSet
trigger1 = 1
x = const(velocity.run.fwd.x)

[State 105, 3]
type = ChangeState
trigger1 = animtime = 0
value = 0

;---------------------------------------------------------------------------
; Come in as a protton guy
[Statedef 116]
type    = S
physics = S
ctrl = 0
anim = 100
sprpriority = 1

[State 0, PosAdd]
type = PosAdd
trigger1 = time = 0
x = -64 - backedgedist

[State 0, ]
type = VarSet
trigger1 = 1
v = 11
value = 7

[State 0, ]
type = VarSet
trigger1 = time = 0
var(55) = 8
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(55)
var(55) = parent,var(55)
[State 0, ]
type = VarSet
trigger1 = time = 0
trigger1 = parent,var(49)
var(55) = parent,var(49)

[State 0, ]
type = ScreenBound
trigger1 = 1
value = 0

[State 105, 1]
type = VelSet
trigger1 = 1
x = const(velocity.run.fwd.x)

[State 0, DestroySelf]
type = DestroySelf
trigger1 = frontedgedist < -88

; Exit followed by a bear
[Statedef 119]
type    = S
physics = S
ctrl = 0
anim = 100
sprpriority = 1

[State 0, PlayerPush]
type = PlayerPush
trigger1 = 1
value = 0
ignorehitpause = 1

[State 0, ]
type = ScreenBound
trigger1 = 1
value = 0

[State 105, 1]
type = VelSet
trigger1 = 1
x = const(velocity.run.fwd.x)

[State 0, DestroySelf]
type = DestroySelf
trigger1 = frontedgedist < -88


;---------------------------------------------------------------------------
; Bioware fanbase as of 2012
[Statedef 1202]
type    = A
movetype= A
physics = N
ctrl = 0
anim = 1202
sprpriority = 4
velset = 0,22.5

;[State 0, AttackMulSet]
;type = AttackMulSet
;trigger1 = 1
;value = parent,fvar(13)
;ignorehitpause = 1

;[State ProRation]
;type = ParentVarSet
;trigger1 = movehit = 1
;fvar(13) = (parent,fvar(13)) * 0.75
;ignorehitpause = 1
;persistent = 0

[State Neo-Juggle-System-Flag]
type = ParentVarSet
;trigger1 = !(var(40) & floor(exp(1*ln(2)) + 0.5) )
trigger1 = movehit = [1,2]
trigger1 = numtarget
var(43) = parent,var(43) | floor(exp(1*ln(2)) + 0.5)
ignorehitpause = 1
persistent = 0

[State 200, 1]
type = HitDef
trigger1 = time = 1
attr = S, SP
damage = 0, 0
animtype = hard
guardflag = H
hitflag = MAF
priority = 5,Hit
pausetime = 0, 0
sparkno = -1
guard.sparkno = -1
sparkxy = 0, 0
hitsound = S0, 14
guardsound = S6, 2
ground.type = High
ground.slidetime = 34
ground.hittime = 34
guard.hittime = 15
ground.velocity = -10
guard.velocity = -5
airguard.velocity = -1.9,-.8
air.type = High
air.velocity = -2,-4
air.hittime = 18
air.fall = 1
fall.recovertime = 40
id = ifelse((parent,var(43) & floor(exp(1*ln(2)) + 0.5) ),1101,1100)
;nochainid = 1100
getpower = 0
givepower = 0
;p2sprpriority = -5
ground.cornerpush.veloff = 0
affectteam = B

[State , Mr.Freeze]
type = TargetState
triggerall = var(4)=0
triggerall = numtarget(1100)
triggerall = movehit = 1
trigger1 = !(target(1100),ishelper)
trigger2 = PlayerIDExist(target(1100),ID)
value = 1105
ID = 1100
ignorehitpause = 1
persistent = 0

;[State , Mr.Freeze]
;type = TargetState
;triggerall = numtarget(1200)
;triggerall = movehit = 1
;trigger1 = !(target(1200),ishelper)
;trigger2 = PlayerIDExist(target(1200),ID)
;value = 1205
;ID = 1200
;ignorehitpause = 1
;persistent = 0

[State 200, 7]
type = ChangeState
trigger1 = pos y >= 0
trigger2 = movecontact
trigger3 = movereversed
value = 1203

[State 0, VarSet]
type = VarSet
trigger1 = 1
var(4) = (p2stateno=1105 && p2movetype = H)
ignorehitpause = 1


;---------------------------------------------------------------------------
; oh hai
[Statedef 1301]
type    = A
movetype= A
physics = N
ctrl = 0
anim = 1302
sprpriority = 4
velset = 0,0

[State Neo-Juggle-System-Flag]
type = ParentVarSet
;trigger1 = !(var(40) & floor(exp(1*ln(2)) + 0.5) )
trigger1 = movehit = [1,2]
trigger1 = numtarget
var(43) = parent,var(43) | floor(exp(3*ln(2)) + 0.5)
ignorehitpause = 1
persistent = 0

[State 0, PalFXWiz]
type = PalFX
trigger1 = 1
time = 2
add = 0,50,240
mul = 120,224,150
color = 0
ignorehitpause = 1

;[State 0, AttackMulSet]
;type = AttackMulSet
;trigger1 = 1
;value = parent,fvar(13)
;ignorehitpause = 1

;[State ProRation]
;type = ParentVarSet
;trigger1 = movehit = 1
;fvar(13) = (parent,fvar(13)) * 0.75
;ignorehitpause = 1
;persistent = 0

[State 200, 1]
type = HitDef
trigger1 = time = 1
attr = S, SP
damage = 0, 0
animtype = hard
guardflag = M
hitflag = MAF
priority = 5,Hit
pausetime = 0, 0
sparkno = -1
guard.sparkno = -1
sparkxy = 0, 0
hitsound = S0, 14
guardsound = S6, 2
ground.type = High
ground.slidetime = 34
ground.hittime = 34
guard.hittime = 15
ground.velocity = 0
guard.velocity = -5
airguard.velocity = -1.9,-.8
air.type = High
air.velocity = -2,-4
air.hittime = 18
air.fall = 1
fall.recovertime = 40
id = 1100
;nochainid = 1100
getpower = 0
givepower = 0
;p2sprpriority = -5
ground.cornerpush.veloff = 0
guard.dist = 0
[State 200, 1]
type = HitDef
trigger1 = time > 1
trigger1 = parent,anim!=1300
attr = S, SP
damage = 0, 0
animtype = hard
guardflag = M
hitflag = MAF
priority = 5,Hit
pausetime = 0, 0
sparkno = -1
guard.sparkno = -1
sparkxy = 0, 0
hitsound = S0, 14
guardsound = S6, 2
ground.type = High
ground.slidetime = 34
ground.hittime = 34
guard.hittime = 15
ground.velocity = 0
guard.velocity = -5
airguard.velocity = -1.9,-.8
air.type = High
air.velocity = -2,-4
air.hittime = 18
air.fall = 1
fall.recovertime = 40
id = 1100
;nochainid = 1100
getpower = 0
givepower = 0
;p2sprpriority = -5
ground.cornerpush.veloff = 0
guard.dist = 0
affectteam = B
persistent = 0

[State , Mr.Freeze]
type = TargetState
triggerall = numtarget(1100)
triggerall = movehit = 1
trigger1 = !(target(1100),ishelper)
trigger2 = PlayerIDExist(target(1100),ID)
value = 1105
ID = 1100
ignorehitpause = 1
persistent = 0

;[State , Mr.Freeze]
;type = TargetState
;triggerall = numtarget(1200)
;triggerall = movehit = 1
;trigger1 = !(target(1200),ishelper)
;trigger2 = PlayerIDExist(target(1200),ID)
;value = 1205
;ID = 1200
;ignorehitpause = 1
;persistent = 0

[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = time >= 60
trigger1 = (time%3)=0
flag = invisible

[State nachos]
type = PlaySnd
trigger1 = time = 90
value = S0,15
[State 0, Explod]
type = Explod
trigger1 = time = 90
anim = 1301
ID = 1301
pos = 0,ceil(-70*const(size.yscale) )
postype = p1
facing = 1
vfacing = 1
bindtime = 1
removetime = -2
scale = 1,1
sprpriority = 5
ownpal = 1

[State 200, 7]
type = DestroySelf
trigger1 = movecontact
trigger2 = movereversed
trigger3 = time >= 100
trigger4 = parent,stateno = 1300
trigger4 = parent,animelemtime(3) = -1

[Statedef 1420]
type    = A
movetype= H
physics = N
velset = 0,0

[State 0, AngleDraw]
type = AngleDraw
trigger1 = animelemtime(32) >= 0 && animelemtime(33) < 0
value = 0
scale = 1.25,1
[State 0, AngleDraw]
type = AngleDraw
trigger1 = animelemtime(33) >= 0 && animelemtime(34) < 0
value = 0
scale = 2,1

[State 820, 1]
type = ChangeAnim2
Trigger1 = Time = 0
value = 1420

[State 0, ScreenBound]
type = ScreenBound
trigger1 = 1
value = 0
movecamera = 0,0
ignorehitpause = 1

[State 0, VelAdd]
type = VelAdd
trigger1 = animelemtime(35) = 1
trigger1 = !alive
y = 99999

[State 820, 2]
type = SelfState
trigger1 = animelemtime(35) >= 3
trigger1 = !alive
value = 5150

[State 0, PosAdd]
type = PosSet
trigger1 = animelem = 36
x = -160+random%320
[State 0, PosAdd]
type = PosAdd
trigger1 = animelem = 36
y = -320
[State 0, VelAdd]
type = VelAdd
trigger1 = animelemtime(37) >= 0
y = 0.88

[State 820, 2]
type = SelfState
trigger1 = animelemtime(37) >= 0
trigger1 = pos y >= 0
trigger1 = vel y > 0
value = 5100

;---------------------------------------------------------------------------
; Win state decider
; CNS difficulty: basic
; CNS x: {
[Statedef 180]
type = S

[State 180, 1]
type = ChangeState
trigger1 = ishelper
trigger1 = Time = 0
value = 181+random%8


;---------------------------------------------------------------------------
; PREINTRO
[Statedef 190]
type = S
ctrl = 0
velset = 0,0

[State 190, 1]
type = ChangeAnim
trigger1 = SelfAnimExist(190)
value = 190

[State 190, 2] ;Go straight to intro.
type = ChangeState
trigger1 = Time = 0
value = 191


;---------------------------------------------------------------------------
; Introduction
; CNS difficulty: basic
; CNS x: {
[Statedef 191]
type = S
ctrl = 0
anim = 190
velset = 0,0

[State 0, ]
type = AssertSpecial
trigger1 = 1
flag = nomusic
flag2 = nobardisplay

[State 0, ]
type = PlaySnd
trigger1 = Time = 0
value = 19,random%5
abspan = 0

[State 191, 2] ;Assert this until you want "round 1, fight" to begin
type = AssertSpecial
trigger1 = 1
flag = Intro

[State 191, 3] ;Change to stand state when done
type = ChangeState
trigger1 = Time >= 150
value = 0

;---------------------------------------------------------------------------
; HIT_LIEDOWN
[Statedef 5110]
type    = L
movetype= H
physics = N

[State 5110, EnvShake]
type = FallEnvShake
trigger1 = Time = 0

[State 5110, 1] ;For hit up/up-diag type (from state 5081)
type = ChangeAnim
persistent = 0
trigger1 = SelfAnimExist(5110 + (anim % 10))
trigger1 = anim = [5081,5089]
value = 5110 + (anim % 10)

[State 5110, 2] ;Hit ground anim (normal)
type = ChangeAnim
triggerall = time = 0
triggerall = anim != [5110,5119] ;Not already changed anim
trigger1 = anim != [5161,5169]
trigger2 = !SelfAnimExist(5170 + (anim % 10))
value = 5170

[State 5110, 3] ;Hit ground anim (for hit up)
type = ChangeAnim
triggerall = time = 0
triggerall = anim != [5110,5119] ;Not already changed anim
trigger1 = anim = [5161,5169]
trigger1 = SelfAnimExist(5170 + (anim % 10))
value = 5170 + (anim % 10)

[State 5110, 4]
type = HitFallDamage
trigger1 = Time = 0

[State 5110, 5]
type = PosSet
trigger1 = Time = 0
y = 0

[State 5110, Var] ;Get fall velocity
type = VarSet
trigger1 = Time = 0
trigger1 = GetHitVar(fall.yvel) != 0
sysvar(1) = floor(vel y)

[State 5110, 6]
type = PlaySnd
trigger1 = Time = 0
trigger1 = !SysVar(0)
;value = F7, 0 ;Hit ground
value = F7, (sysvar(1) > 5) + (sysvar(1) > 14)

[State 5110, 7]
type = GameMakeAnim
trigger1 = Time = 0
trigger1 = !SysVar(0)
value = 60 + (sysvar(1) > 5) + (sysvar(1) > 14)
pos = 0, 0
under = sysvar(1) <= 10

[State 5110, 8]
type = VelSet
trigger1 = Time = 0
y = 0

[State 5110, 9] ;For hit up type
type = ChangeAnim
persistent = 0
triggerall = anim = [5171,5179]
triggerall = SelfAnimExist(5110 + (anim % 10))
trigger1 = AnimTime = 0
trigger2 = SysVar(0) ;SysVar(0) = 1 avoids hit ground anim
value = 5110 + (anim % 10)

[State 5110, 10] ;For normal
type = ChangeAnim
persistent = 0
triggerall = Anim != [5111,5119]
trigger1 = AnimTime = 0
trigger2 = SysVar(0) ;SysVar(0) = 1 avoids hit ground frame
value = 5110

[State 5110, 11] ;If just died
type = ChangeState
triggerall = !alive
trigger1 = AnimTime = 0
trigger2 = SysVar(0) ;SysVar(0) = 1 avoids hit ground frame
trigger3 = Anim = [5110,5119]
value = 5150

;[State 5110, 11] ;If just died
;type = ChangeState
;triggerall = ishelper
;triggerall = var(10) >= 250
;trigger1 = AnimTime = 0
;trigger2 = SysVar(0) ;SysVar(0) = 1 avoids hit ground frame
;trigger3 = Anim = [5110,5119]
;value = 5150

[State 5110, 12]
type = VarSet
trigger1 = SysVar(0)
trigger1 = Time = 0
sysvar(0) = 0

[State 5110, 13] ;Friction
type = VelMul
trigger1 = 1
x = 0.85

[State 5110, 14]
type = ForceFeedback
trigger1 = alive
trigger1 = Time = 0
time = 8
ampl = 240
waveform = sine

[State 5110, 15]
type = ForceFeedback
trigger1 = !alive
trigger1 = Time = 0
ampl = 200, 7, -.467
time = 30
waveform = sine


;---------------------------------------------------------------------------
; HIT_LIEDEAD
[Statedef 5150]
type    = L
movetype= H
physics = N
sprpriority = -3

[State 5150, 1]
type = poweradd
trigger1 = Time = 0
value = 500

;[State 5150, 1]
;type = parentvaradd
;trigger1 = Time = 0
;v = 53
;value = 1

[State 5150, 1] ;Normal anim
type = ChangeAnim
triggerall = Time = 0
triggerall = SelfAnimExist(5140)
trigger1 = (anim != [5111,5119]) && (anim != [5171,5179])
trigger2 = !SelfAnimExist(5140 + (anim % 10))
value = 5140

[State 5150, 3] ;Hit up type anim
type = ChangeAnim
trigger1 = Time = 0
trigger1 = (anim = [5111,5119]) || (anim = [5171,5179])
trigger1 = SelfAnimExist(5140 + (anim % 10))
value = 5140 + (anim % 10)

[State 5150, 4] ;Match over anim
type = ChangeAnim
persistent = 0
;trigger1 = Time = 0
trigger1 = MatchOver = 1
trigger1 = Anim = [5140,5149]
trigger1 = SelfAnimExist(anim+10)
value = anim+10

[State 5150, 5] ;Switch to 5110 if liedead anim does not exist
type = ChangeAnim
trigger1 = Time = 0
trigger1 = Anim != [5140,5159]
trigger1 = Anim != [5110,5119]
value = 5110

[State 5150, 6] ;Friction
type = VelMul
trigger1 = 1
x = 0.85

[State 5150, 7] ;Friction
type = VelSet
trigger1 = Vel x < .05
persistent = 0
x = 0

[State 5150, 8]
type = NotHitBy
trigger1 = 1
value = SCA
time = 1

[State 0, ]
type = AssertSpecial
trigger1 = ishelper
trigger1 = (time%3)=0
flag = invisible

[State 0, ]
type = DestroySelf
trigger1 = ishelper
trigger1 = time >= 40



[Statedef -3]

[State 0, NotHitBy]
type = NotHitBy
trigger1 = !ishelper
value = SCA,NA,SA,HA,NP,SP,HP,NT,ST,HT
time = 2
ignorehitpause = 1

[State 0, ]
type = AssertSpecial
trigger1 = !ishelper
flag = invisible
flag2 = nowalk
ignorehitpause = 1

[State 0, ]
type = AssertSpecial
triggerall = !ishelper
trigger1 = alive
flag = timerfreeze
ignorehitpause = 1

[State 0, ]
type = AssertSpecial
triggerall = !ishelper
trigger1 = !alive
flag = nokosnd
ignorehitpause = 1

[State 0, ]
type = PosAdd
trigger1 = !ishelper
x = p2dist x - 666

[State 0, ]
type = ScreenBound
trigger1 = roundstate != 1
trigger1 = !ishelper
value = 0

[State 0, ]
type = ChangeState
triggerall = !ishelper
trigger1 = stateno = 0 || (stateno = [10,12]) || (stateno = [40,59])
trigger1 = roundstate != [3,4]
value = 1
ctrl = 0

[State 0, ]
type = Turn
triggerall = !ishelper
trigger1 = facing = enemy , facing

[State 0, ]
type = LifeAdd
triggerall = !ishelper
trigger1 = var(53) >= 1
value = -24
absolute = 1
ignorehitpause = 1

[State 0, ]
type = VarAdd
triggerall = !ishelper
trigger1 = var(53) >= 1
v = 53
value = -1
ignorehitpause = 1



[State DUN DUN DUUUNNNNNNNNNNNNNNNN]
type = PlaySnd
triggerall = anim = 42 || anim = 43
trigger1 = animelem = 2
trigger2 = animtime = 0
value = S0,2

[State 0, Backfire]
type = ChangeState
triggerall = stateno != 1105
trigger1 = numhelper(1100)
trigger1 = helper(1100),stateno = 1103
trigger1 = helper(1100),time = [0,1]
trigger1 = helper(1100),var(4) = 1
trigger1 = helper(1100),numtarget
trigger2 = numhelper(1200)
trigger2 = helper(1200),stateno = 1203
trigger2 = helper(1200),time = [0,1]
trigger2 = helper(1200),var(4) = 1
trigger2 = helper(1200),numtarget
value = 1105
ctrl = 0

; Straight outta POTS
[State -3, Prevent Undergound Juggles]
type= targetbind
trigger1 =stateno!=[800,890] ; better exclude this happening during throws
trigger1 =stateno!=[430,440] ; as well as attacks that can OTG
trigger1= movehit=1
trigger1= numtarget=1 && numenemy
trigger1= (target,time<=1) && (target,ID=enemynear,ID); this is just to prevent Simul issues as usual
trigger1= !(target,hitshakeover) && (target, hitfall) && (target, pos y>0)
trigger1= !(target,statetype=L) && !(target,stateno=[5080,5120])
pos= ceil(p2dist x), ceil(-pos y); keeps P2 at the same horizontal distance, but resets his Y position
ignorehitpause= 1

;[State -3, Variable Height]
;type= playerpush
;triggerall= statetype=A && movetype!=H && numenemy
;triggerall= p2bodydist x = [-(enemynear,const(size.ground.back) + enemynear,const(size.ground.front)), 0]; checks if both characters are within each other's width
;trigger1= p2statetype=S
;trigger1= p2dist y >= (enemynear,const(size.height) - 22)
;trigger2= p2statetype=C
;trigger2= p2dist y >= (enemynear,const(size.height) - 48)
;trigger3= p2statetype=L
;trigger3= p2dist y >= 11
;value= 0
;ignorehitpause= 1


;This controller plays a sound everytime KFM lands from a jump, or
;from his back-dash.
[State -3, Landing Sound]
type = PlaySnd
triggerall = Time = 1
trigger1 = stateno = 52 ;Jump land
trigger2 = stateno = 106 ;Run-back land
value = 40, 0

; Kamek and Luchini appear to have been the first ones to use the IsHomeTeam AI
; activation concept.
; Feel free to move this controller to your character's intro state for slightly
; better efficiency.
[State -3, SetAI]
type = VarSet
triggerall = Alive && !IsHelper
triggerall = IsHomeTeam
trigger1 = TeamSide = 2
trigger2 = MatchNo > 1
var(58) = 1

;[State 0, ]
;type = DestroySelf
;trigger1 = ishelper
;trigger1 = time >= 40

[State -3, AI Helper - Compatibly Partnered Version]
type = Helper
trigger1 = !var(58) && !IsHelper
trigger1 = !NumHelper(9742)
trigger1 = Alive && RoundState = 2
trigger1 = NumPartner
trigger1 = Partner,SelfAnimExist(9741)
HelperType = normal
name = "AI Helper (Simul Version)"
ID = 9742
pos = 9999999,99999
StateNo = 9742
KeyCtrl = 1
PauseMoveTime = 2147483647
SuperMoveTime = 2147483647

; If you want to use the Guard mode, Dummy mode, Distance, or Button jam dummy
; control options in Training mode without activating the dummy's AI while
; working on the character, then all you need to do is temporarily disable
; this controller.  Or, if you want to permanently disable this controller in
; Training mode, then you could use the Training mode detection code available
; from my site ( http://www.mugenguild.net/~winane/ ), and then just add a
; "(var(59)&63)>30" triggerall to this controller.
; Alternatively, you can just set "Dummy control" to "Manual", press a P2 button
; to kill the AI helper, and then set dummy control back to "Cooperative".  (In
; fact, setting dummy control to manual isn't even necessary, if you press the
; P2 button prior to the first time you pause.)
[State -3, AI Helper]
type = Helper
triggerall = !var(58) && !IsHelper
triggerall = !NumHelper(9741)
triggerall = Alive && RoundState = 2
trigger1 = !NumPartner
trigger2 = !(Partner,SelfAnimExist(9741))
HelperType = normal
name = "AI Helper"
ID = 9741
pos = 9999999,99999
StateNo = 9741
KeyCtrl = 1
PauseMoveTime = 2147483647
SuperMoveTime = 2147483647

[State -3, TurnBackOnAI]
type = VarSet
trigger1 = var(58) = -2 && !IsHelper
trigger1 = Alive && RoundState = 2
var(58) = 1

; This method works somewhat in Linux Mugen version 2002.04.14,
; whereas the old humanly-impossible commands method does not.
; It is very important that this controller NOT be moved to State -2.
; Note that this part won't work nearly as well if AI.Cheat is turned off
; in mugen.cfg.
[State -3, XOR]
type = VarSet
triggerall = var(58)!=1 && !IsHelper
triggerall = !var(56)
triggerall = var(57) = GameTime-1
trigger1 = command = "a" ^^ command = "a2"
trigger2 = command = "b" ^^ command = "b2"
trigger3 = command = "c" ^^ command = "c2"
trigger4 = command = "x" ^^ command = "x2"
trigger5 = command = "y" ^^ command = "y2"
trigger6 = command = "z" ^^ command = "z2"
trigger7 = command = "start" ^^ command = "start2"
trigger8 = command = "holda" ^^ command = "holda2"
trigger9 = command = "holdb" ^^ command = "holdb2"
trigger10 = command = "holdc" ^^ command = "holdc2"
trigger11 = command = "holdx" ^^ command = "holdx2"
trigger12 = command = "holdy" ^^ command = "holdy2"
trigger13 = command = "holdz" ^^ command = "holdz2"
trigger14 = command = "holdstart" ^^ command = "holdstart2"
trigger15 = command = "holdfwd" ^^ command = "holdfwd2"
trigger16 = command = "holdback" ^^ command = "holdback2"
trigger17 = command = "holdup" ^^ command = "holdup2"
trigger18 = command = "holddown" ^^ command = "holddown2"
trigger19 = command = "recovery" ^^ command = "recovery2"
;Add more as desired. (See my notes in the CMD.)
var(58) = 1

; These next two controllers must be placed here, after the above XOR
; VarSet controller and before the below GameTime VarSet controller.
[State -3, fiXOR]
type = VarAdd
trigger1 = var(56) > 0 && !IsHelper
var(56) = -1

[State -3, fuXOR]
type = VarSet
trigger1 = var(57) < GameTime-1 && !IsHelper
var(56) = 31
IgnoreHitPause = 1

; It is very important that this controller NOT be moved to State -2, as putting
; it there would defeat the entire purpose of the controller, allowing the
; helper method or the XOR method to erroneously set the AI variable.
; And within State -3, don't put any ChangeState controllers before this
; controller, lest you unnecessarily delay your character's AI activation.
[State -3, GameTimeVar]
type = VarSet
trigger1 = !IsHelper
var(57) = GameTime
IgnoreHitPause = 1

; Within StateDef -3, none of your own AI-related code should come after the code
; provided here (and putting it before the code is also generally a bad idea).
; It's better to use State -1 (or, in special circumstances, State -2) instead.

